#include "mMainView.h"

//------------- Const Char's -------------------------------------------------------------

//------------- Const BRect's ------------------------------------------------------------
const BRect mMainViewFrame				(0, 0, 400, 400);
const BRect mNextButtonFrame			(330, 370, 390, 390);
const BRect mBackButtonFrame			(260, 370, 320, 390);
const BRect mCancelButtonFrame			(190, 370, 250, 390);
const BRect mBoxFrame					(5, 10, 300, 250);
const BRect mClassNameControlFrame		(10, 30, 290, 60);
const BRect mFileNameControlFrame		(10, 70, 260, 100);
const BRect mTextViewFrame				(262, 75, 290, 100);
const BRect mAppSigControlFrame			(10, 110, 290, 140);

//------------- Const rgb_color's --------------------------------------------------------
const rgb_color mBack = 				(ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = 				{50, 102, 152, 111};
const rgb_color mBlack = 				{0, 0, 0, 255};
const rgb_color mWhite = 				{255, 255, 255, 255};

mMainView::mMainView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
					: BView(mMainViewFrame, "mMainViewFrame", B_FOLLOW_ALL, B_WILL_DRAW)
{
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mBlack);
SetDrawingMode(B_OP_COPY);

mBox = new BBox(mBoxFrame, "mBox@mainview");
mBox->SetLabel("Settings and names");
mClassNameControl = new BTextControl(mClassNameControlFrame, "mClassNameControl@mainview",
							"Application Class-name", "MyApp", new BMessage(MSG_TXTCTRL));
mFileNameControl = new BTextControl(mFileNameControlFrame, "mFileNameControl@mainview",
						"App class filename", "App", new BMessage(MSG_TXTCTRL));
mAppSigControl = new BTextControl(mAppSigControlFrame, "mAppSigControl@mainview",
						"App signature", "application/x-vnd.WizardApp", new BMessage(MSG_TXTCTRL));
mClassNameControl->SetDivider(120);
mFileNameControl->SetDivider(120);
mAppSigControl->SetDivider(120);

mTextView = new BTextView(mTextViewFrame, "mTextView", BRect(0, 0, 28, 30), B_FOLLOW_ALL);
mTextView->MakeEditable(false);
mTextView->SetViewColor(mBack);
mTextView->SetText(".cpp");

//We add our stuff
mNextButton = new BButton(mNextButtonFrame, "mNextButton", "Next",
										new BMessage(MSG_NEXTVIEW_3), B_FOLLOW_ALL);
mBackButton = new BButton(mBackButtonFrame, "mBackButton", "Back",
										new BMessage(MSG_PREVVIEW_3), B_FOLLOW_ALL);
mCancelButton = new BButton(mCancelButtonFrame, "mCancelButton", "Cancel",
										new BMessage(MSG_CANCEL), B_FOLLOW_ALL);

AddChild(mBox);
mBox->AddChild(mClassNameControl);
mBox->AddChild(mFileNameControl);
mBox->AddChild(mTextView);
mBox->AddChild(mAppSigControl);
AddChild(mNextButton);
AddChild(mBackButton);
AddChild(mCancelButton);
}

//------------------------------------------------------------------------------------
mMainView::~mMainView()
{


}

//------------------------------------------------------------------------------------
void mMainView::MessageReceived(BMessage* message)
{



}

//------------------------------------------------------------------------------------
void mMainView::Draw(BRect updateRect)
{

}