#include "mSelectView.h"

//------------- Const Char's -------------------------------------------------------------

//------------- Const BRect's ------------------------------------------------------------
const BRect mSelectViewFrame			(0, 0, 400, 400);
const BRect mNextButtonFrame			(330, 370, 390, 390);
const BRect mBackButtonFrame			(260, 370, 320, 390);
const BRect mCancelButtonFrame			(190, 370, 250, 390);
const BRect mCheckBoxBoxFrame			(5, 10, 250, 160);
const BRect mAppCheckBoxFrame			(10, 30, 110, 60);
const BRect mWindowCheckBoxFrame		(10, 70, 110, 100);
const BRect mViewCheckBoxFrame			(10, 110, 110, 140);
const BRect mPathBoxFrame				(5, 170, 250, 330);
const BRect mPathControlFrame			(10, 80, 240, 110);
const BRect mExecNameControlFrame		(10, 45, 240, 75);
const BRect mProjNameControlFrame		(10, 10, 240, 40);
const BRect mBrowseButtonFrame			(130, 120, 240, 150);

//------------- Const rgb_color's --------------------------------------------------------
const rgb_color mBack = 				(ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = 				{50, 102, 152, 111};
const rgb_color mBlack = 				{0, 0, 0, 255};
const rgb_color mWhite = 				{255, 255, 255, 255};

mSelectView::mSelectView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
					: BView(mSelectViewFrame, "mSelectViewFrame", B_FOLLOW_ALL, B_WILL_DRAW)
{
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mBlack);
SetDrawingMode(B_OP_COPY);

mCheckBoxBox = new BBox(mCheckBoxBoxFrame, "mCheckBoxBox");
mAppCheckBox = new BCheckBox(mAppCheckBoxFrame, "mAppCheckBox" ,"Application",
								new BMessage(MSG_APPCHECKBOX));
mWindowCheckBox = new BCheckBox(mWindowCheckBoxFrame, "mWindowCheckBox" ,"Window",
								new BMessage(MSG_WINCHECKBOX));
mViewCheckBox = new BCheckBox(mViewCheckBoxFrame, "mViewCheckBox" ,"View",
								new BMessage(MSG_VIEWCHECKBOX));
mCheckBoxBox->SetLabel("What do you want to generate code to?");
mAppCheckBox->SetValue(true);
mAppCheckBox->SetEnabled(false);
mWindowCheckBox->SetValue(true);
mViewCheckBox->SetValue(true);

mPathBox = new BBox(mPathBoxFrame, "mPathBox");
mPathBox->SetLabel("Path");
mPathControl = new BTextControl(mPathControlFrame, "mPathControl@selectview", "Project path",
								"/boot/home/develop/Project1", new BMessage(MSG_TXTCTRL));
mExecNameControl = new BTextControl(mExecNameControlFrame, "mExecNameControl@selectview", "Executable name",
								"BeApp", new BMessage(MSG_TXTCTRL));
mProjNameControl = new BTextControl(mProjNameControlFrame, "mProjNameControl@selectview", "Project name",
								"Project1", new BMessage(MSG_TXTCTRL));

mBrowseButton = new BButton(mBrowseButtonFrame, "mBrowseButton", "Browse", new BMessage(MSG_BROWSE));

mPathControl->SetDivider(90);
mExecNameControl->SetDivider(90);
mProjNameControl->SetDivider(90);

//We add our stuff
mNextButton = new BButton(mNextButtonFrame, "mNextButton", "Next",
										new BMessage(MSG_NEXTVIEW_2), B_FOLLOW_ALL);
mBackButton = new BButton(mBackButtonFrame, "mBackButton", "Back",
										new BMessage(MSG_PREVVIEW_2), B_FOLLOW_ALL);
mCancelButton = new BButton(mCancelButtonFrame, "mCancelButton", "Cancel",
										new BMessage(MSG_CANCEL), B_FOLLOW_ALL);
		
AddChild(mPathBox);		
mPathBox->AddChild(mPathControl);
mPathBox->AddChild(mExecNameControl);
mPathBox->AddChild(mProjNameControl);
mPathBox->AddChild(mBrowseButton);		
AddChild(mCheckBoxBox);
mCheckBoxBox->AddChild(mAppCheckBox);
mCheckBoxBox->AddChild(mWindowCheckBox);
mCheckBoxBox->AddChild(mViewCheckBox);
AddChild(mNextButton);
AddChild(mBackButton);
AddChild(mCancelButton);
}

//------------------------------------------------------------------------------------
mSelectView::~mSelectView()
{


}

//------------------------------------------------------------------------------------
void mSelectView::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
	case MSG_OPEN:
	BString tmp;
	cout << "Here" << endl;
	message->FindString("file", &tmp);
	mPathControl->SetText(tmp.String());
	cout << tmp.String() << endl;
	break;
	}
}

//------------------------------------------------------------------------------------
void mSelectView::Draw(BRect updateRect)
{

}
