#include "mWindow.h"

//------------- Const Char's --------------------------------------------------------
const char* mWindowTitle =				"BWindowWizard";

//------------- Const BRect's --------------------------------------------------------
const BRect mWindowRect 				(100, 100, 500, 500);
const BRect mViewFrame					(0, 0, 400, 400);

//------------- Const rgb_color's --------------------------------------------------------


mWindow::mWindow(const char* WindowTitle)
			: BWindow(mWindowRect, mWindowTitle, B_TITLED_WINDOW, B_NOT_RESIZABLE)
{
//Set up stuff
SetTitle(mWindowTitle);
//Start the view's
//The initial view
mfirstview = new mFirstView(mViewFrame, "mfirstview", B_FOLLOW_ALL, NULL);
//The view where the user selects what parts he wants
mselectview = new mSelectView(mViewFrame, "mselectview", B_FOLLOW_ALL, NULL);
//Preference for the main.cpp file
mmainview = new mMainView(mViewFrame, "mmainview", B_FOLLOW_ALL, NULL);
//Preference for the window.cpp file
mwindowview = new mWindowView(mViewFrame, "mwindowview", B_FOLLOW_ALL, NULL);
//Preference for the view.cpp file
mviewview = new mViewView(mViewFrame, "mviewview", B_FOLLOW_ALL, NULL);

AddChild(mfirstview);
AddChild(mselectview);
AddChild(mmainview);
AddChild(mwindowview);
AddChild(mviewview);
//We hide all the view's that we do not want at startup
mselectview->Hide();
mmainview->Hide();
mwindowview->Hide();
mviewview->Hide();
}

//-----------------------------------------------------------------------
mWindow::~mWindow()
{


}

//-----------------------------------------------------------------------
void mWindow::SetFolderOpened(const char* path)
{
LockLooper();
mselectview->mPathControl->SetText(path);
UnlockLooper();
}


//-----------------------------------------------------------------------
void mWindow::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
	case MSG_BROWSE:
		//Use be_app's RefsReceived to get the FilePanelPath
		be_app->PostMessage(MSG_OPEN);
	break;
	case MSG_OPEN:
		cout << "Here" << endl;
		message->FindString("file", &tmp);
		mselectview->mPathControl->SetText(tmp.String());
		cout << tmp.String() << endl;
	break;
	//for mFirstView
	case MSG_NEXTVIEW_1:
		mfirstview->Hide();
		mselectview->Show();
	break;
	case MSG_PREVVIEW_1:
		//Disabled
	break;
	//for mSelectView
	case MSG_NEXTVIEW_2:
		SetFinishOnCorrectButton();
		path.SetTo(mselectview->mPathControl->Text());
		cout << path.Path() << endl;
		
		tmp.SetTo("mkdir -p ");
		tmp.Append(path.Path());
		cout << path.Path() << endl;
		system(tmp.String());
			if (!strcmp(mselectview->mPathControl->Text(), "") ||
			!strcmp(mselectview->mExecNameControl->Text(), "")	||
			!strcmp(mselectview->mProjNameControl->Text(), ""))
			{
			BAlert * mAlert = new BAlert("BALert", "Please fill in al the fields", "OK");
			mAlert->Go();
			}
			else
			{
			mselectview->Hide();
			mmainview->Show();
			}
	break;
	case MSG_PREVVIEW_2:
		mselectview->Hide();
		mfirstview->Show();
		//We are at the first view, disable the back button
		mfirstview->mBackButton->SetEnabled(false);
	break;
	//for mMainView
	case MSG_NEXTVIEW_3:
		SetFinishOnCorrectButton();
		if (!strcmp(mmainview->mClassNameControl->Text(), "") ||
			!strcmp(mmainview->mFileNameControl->Text(), ""))
		{
		BAlert * mAlert = new BAlert("BALert", "Please fill in al the fields", "OK");
		mAlert->Go();
		}
		else
		{
			if (mselectview->mWindowCheckBox->Value() == true)
			{
			mmainview->Hide();
			mwindowview->Show();
			}
			else
			{
				if (mselectview->mViewCheckBox->Value() == true)
				{
				mmainview->Hide();
				mviewview->Show();
				}
				else
				{
				GenerateCode();
				}
			}
		}
	break;
	case MSG_PREVVIEW_3:
		mmainview->Hide();
		mselectview->Show();
	break;
	//for mWindowView
	case MSG_NEXTVIEW_4:
		SetFinishOnCorrectButton();
		if (!strcmp(mwindowview->mClassNameControl->Text(), "") ||
			!strcmp(mwindowview->mWindowTitleControl->Text(), "") ||
			!strcmp(mwindowview->mFileNameControl->Text(), ""))
		{
		BAlert * mAlert = new BAlert("BALert", "Please fill in al the fields", "OK");
		mAlert->Go();
		}
		else
		{
			if (mselectview->mViewCheckBox->Value() == true)
			{
			mwindowview->Hide();
			mviewview->Show();
			}
			else
			{
			GenerateCode();
			}
		}
	break;
	case MSG_PREVVIEW_4:
		mwindowview->Hide();
		mmainview->Show();
	break;
	//for mViewView
	case MSG_NEXTVIEW_5:
		GenerateCode();
	break;
	case MSG_PREVVIEW_5:
		mviewview->Hide();
		mwindowview->Show();
	break;
	case MSG_CANCEL:
		PostMessage(B_QUIT_REQUESTED);
	break;
	case MSG_APPCHECKBOX:
		//Thisone cant be invoced, its disabled:-D
	break;
	case MSG_WINCHECKBOX:
		if (mselectview->mWindowCheckBox->Value() == false)
		{
		mselectview->mViewCheckBox->SetValue(false);
		}
		else
		{

		}
	break;
	case MSG_VIEWCHECKBOX:
		if (mselectview->mWindowCheckBox->Value() == false)
		{
		mselectview->mWindowCheckBox->SetValue(true);
		}
	break;
	default:
		
	break;
	}
}

//-----------------------------------------------------------------------
bool mWindow::QuitRequested()
{
be_app->PostMessage(B_QUIT_REQUESTED);
return BWindow::QuitRequested();
}

//-----------------------------------------------------------------------
void mWindow::SetFinishOnCorrectButton()
{
	if (mselectview->mWindowCheckBox->Value() == false)
	{
	mmainview->mNextButton->SetLabel("Finish");
	mwindowview->mNextButton->SetLabel("Next");
	mviewview->mNextButton->SetLabel("Next");
	}
	else
	{
	mmainview->mNextButton->SetLabel("Next");
	mwindowview->mNextButton->SetLabel("Finish");
	mviewview->mNextButton->SetLabel("Next");
	}
	if (mselectview->mViewCheckBox->Value() == true)
	{
	mmainview->mNextButton->SetLabel("Next");
	mwindowview->mNextButton->SetLabel("Next");
	mviewview->mNextButton->SetLabel("Finish");
	}
}

//-----------------------------------------------------------------------
void mWindow::GenerateCode()
{
GenStuff();
GenApp();
	if (mselectview->mWindowCheckBox->Value() == true)
	{
	GenWin();
	}
	if (mselectview->mViewCheckBox->Value() == true)
	{
	GenView();
	}
GenMake();
PostMessage(B_QUIT_REQUESTED);
}

//-----------------------------------------------------------------------
void mWindow::GenStuff()
{

}

//-----------------------------------------------------------------------
void mWindow::GenApp()
{
//Make the main cpp file
tmp.SetTo(mselectview->mPathControl->Text());
tmp.Append("/");
tmp.Append(mmainview->mFileNameControl->Text());
tmp.Append(".cpp");
cout << tmp.String() << endl;
file = fopen(tmp.String(), "w");
//Add the content of that file
SaveString.SetTo("");
SaveString << "//-----------------------  Local includes  ----------------------\n";
SaveString << "#include \"" << mmainview->mFileNameControl->Text() << ".h\"";
SaveString << "\n\n//----------------------- Global includes  ----------------------\n\n\n";
SaveString << "//---------------------------------------------------------------\n";
SaveString << "int main(int32 argc, char** argv)\n{\nnew ";
SaveString << mmainview->mClassNameControl->Text() << "();\nbe_app->Run();\nreturn(0);\n}\n\n";
SaveString << "//---------------------------------------------------------------\n";
SaveString << mmainview->mClassNameControl->Text() << "::" << mmainview->mClassNameControl->Text() << "()";
SaveString << "\n\t\t: BApplication(ApplicationSignature)\n{\n\n}\n\n";
SaveString << "//---------------------------------------------------------------\n";
SaveString << mmainview->mClassNameControl->Text() << "::~" << mmainview->mClassNameControl->Text();
SaveString << "()\n{\n\n}\n\n//---------------------------------------------------------------\n";
SaveString << "void " << mmainview->mClassNameControl->Text() << "::ReadyToRun()\n{\n";
	if (mselectview->mWindowCheckBox->Value() == true)
	{
	SaveString << "_" << mwindowview->mClassNameControl->Text() << " = new ";
	SaveString << mwindowview->mClassNameControl->Text() << "();";
	SaveString << "\n\tif (_" << mwindowview->mClassNameControl->Text() << " != NULL)\n\t{\n\t_";
	SaveString << mwindowview->mClassNameControl->Text() << "->Show();\n\t}\n\telse\n\t{";
	SaveString << "\n\tbe_app->PostMessage(B_QUIT_REQUESTED);\n\t}";
	}
SaveString << "\n}\n";
fprintf(file, SaveString.String());
fclose(file);
//main header file
tmp.SetTo(mselectview->mPathControl->Text());
tmp.Append("/");
tmp.Append(mmainview->mFileNameControl->Text());
tmp.Append(".h");
cout << tmp.String() << endl;
file = fopen(tmp.String(), "w");
//Add the content of that file
SaveString.SetTo("");
SaveString << "#ifndef _" << mmainview->mClassNameControl->Text() << "_h_";
SaveString << "\n#define _" << mmainview->mClassNameControl->Text() << "_h_";
SaveString << "\n\n#define ApplicationSignature \"";
SaveString << mmainview->mAppSigControl->Text() << "\"\n\n";
SaveString << "#include <iostream.h>\n#include <stdio.h>\n#include <stdlib.h>\n#include <AppKit.h>\n\n";
	if (mselectview->mWindowCheckBox->Value() == true)
	{
	SaveString << "#include \"" << mwindowview->mFileNameControl->Text() << ".h\"\n\n";
	}
SaveString << "class " << mmainview->mClassNameControl->Text() << " : public BApplication\n{";
SaveString << "\npublic:\n\t\t\t\t\t\t" << mmainview->mClassNameControl->Text() << "();\n";
SaveString << "\t\t\t\t\t\t~" << mmainview->mClassNameControl->Text() << "();\n";
SaveString << "\tvirtual void\t\tReadyToRun();\nprivate:\n";
	if (mselectview->mWindowCheckBox->Value() == true)
	{
	SaveString << "\t" << mwindowview->mClassNameControl->Text() << "*\t\t\t";
	SaveString << "_" << mwindowview->mClassNameControl->Text();
	}
SaveString << ";\n\n};\n\n#endif\n";
fprintf(file, SaveString.String());
fclose(file);
}

//-----------------------------------------------------------------------
void mWindow::GenWin()
{
//Make the window cpp file
tmp.SetTo(mselectview->mPathControl->Text());
tmp.Append("/");
tmp.Append(mwindowview->mFileNameControl->Text());
tmp.Append(".cpp");
cout << tmp.String() << endl;
file = fopen(tmp.String(), "w");
//Add the content of that file
SaveString.SetTo("");
SaveString << "//-----------------------  Local includes  ----------------------\n";
SaveString << "#include \"" << mwindowview->mFileNameControl->Text() << ".h\"\n";
SaveString << "\n//----------------------- Global includes  ----------------------\n\n";
SaveString << "\n//---------------------------------------------------------------";
SaveString << "\n" << mwindowview->mClassNameControl->Text() << "::" << mwindowview->mClassNameControl->Text();
SaveString << "()\n\t\t\t : BWindow(BRect(100, 100, 500, 500), \"" << mwindowview->mWindowTitleControl->Text();
SaveString << "\" ,B_TITLED_WINDOW, 0)\n{\n";
	if (mselectview->mViewCheckBox->Value() == true)
	{
	SaveString << "_" << mviewview->mClassNameControl->Text() << " = new ";
	SaveString << mviewview->mClassNameControl->Text() << "(BRect(0, 0, 400, 400),";
	SaveString << "\"mViewName\", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW);\n\nAddChild(_";
	SaveString << mviewview->mClassNameControl->Text() << ");\n}\n\n";
	}
	else
	{
	SaveString << "\n\n}\n\n";
	}
SaveString << "//---------------------------------------------------------------\n";
SaveString << mwindowview->mClassNameControl->Text() << "::~" << mwindowview->mClassNameControl->Text();
SaveString << "()\n{\n\n}\n\n//---------------------------------------------------------------\n";
SaveString << "void " << mwindowview->mClassNameControl->Text() << "::MessageReceived(BMessage *message)";
SaveString << "\n{\n\tswitch(message->what)\n\t{\n\tdefault:\n\t\n\tbreak;\n\t}\n}";
SaveString << "\n\n//---------------------------------------------------------------";
SaveString << "\nbool " << mwindowview->mClassNameControl->Text() << "::QuitRequested()\n{";
SaveString << "\n\tbe_app->PostMessage(B_QUIT_REQUESTED);\n\treturn BWindow::QuitRequested();\n}\n\n";
fprintf(file, SaveString.String());
fclose(file);
//Make the window header file
tmp.SetTo(mselectview->mPathControl->Text());
tmp.Append("/");
tmp.Append(mwindowview->mFileNameControl->Text());
tmp.Append(".h");
cout << tmp.String() << endl;
file = fopen(tmp.String(), "w");
//Add the content of that file
SaveString.SetTo("");
SaveString << "#ifndef _" << mwindowview->mFileNameControl->Text() << "_h_\n";
SaveString << "#define _" << mwindowview->mFileNameControl->Text() << "_h_\n\n";
SaveString << "//-----------------------  Local includes  ----------------------\n";
	if (mselectview->mViewCheckBox->Value() == true)
	{
	SaveString << "#include \"" << mviewview->mFileNameControl->Text() << ".h\"";
	}
SaveString << "\n\n//----------------------- Global includes  ----------------------\n";
SaveString << "#include <AppKit.h>\n#include <SupportKit.h>\n#include <InterfaceKit.h>";
SaveString << "\n#include <iostream.h>\n#include <stdio.h>\n#include <stdlib.h>\n\n";
SaveString << "class " << mwindowview->mClassNameControl->Text() << "\n\t\t : public BWindow\n";
SaveString << "{\npublic:\n\t\t\t\t\t\t" << mwindowview->mClassNameControl->Text() << "();";
SaveString << "\n\t\t\t\t\t\t~" << mwindowview->mClassNameControl->Text() << "();";
SaveString << "\n\tvirtual void\t\tMessageReceived(BMessage *message);";
SaveString << "\n\tvirtual bool\t\tQuitRequested();";
SaveString << "\n\nprivate:\n";
	if (mselectview->mViewCheckBox->Value() == true)
	{
	SaveString << "\t" << mviewview->mClassNameControl->Text() << "*\t\t\t\t_";
	SaveString << mviewview->mClassNameControl->Text() << ";";
	}

SaveString << "\n};\n\n#endif\n";
fprintf(file, SaveString.String());
fclose(file);
}

//-----------------------------------------------------------------------
void mWindow::GenView()
{
//Make the view cpp file
tmp.SetTo(mselectview->mPathControl->Text());
tmp.Append("/");
tmp.Append(mviewview->mFileNameControl->Text());
tmp.Append(".cpp");
cout << tmp.String() << endl;
file = fopen(tmp.String(), "w");
//Add the content of that file
SaveString.SetTo("");
SaveString << "//-----------------------  Local includes  ----------------------\n";
SaveString << "#include \"" << mviewview->mFileNameControl->Text() << ".h\"\n\n";
SaveString << "//-----------------------  Global includes  ----------------------\n\n\n";
SaveString << "//---------------------------------------------------------------\n";
SaveString << mviewview->mClassNameControl->Text() << "::" << mviewview->mClassNameControl->Text();
SaveString << "(BRect frame, const char *name, uint32 resizeMask, uint32 flags)\n";
SaveString << "\t\t: BView(BRect(0, 0, 400, 400), \"MyViewName\", B_FOLLOW_LEFT | B_FOLLOW_TOP,\n\t\t";		 
SaveString << "B_WILL_DRAW)\n{\n\n\n\n}\n\n";
SaveString << "//---------------------------------------------------------------\n";
SaveString << mviewview->mClassNameControl->Text() << "::~" << mviewview->mClassNameControl->Text();
SaveString << "()\n{\n\n}\n\n//---------------------------------------------------------------\n";
SaveString << "void " << mviewview->mClassNameControl->Text() << "::MessageReceived(BMessage *message)";
SaveString << "\n{\n\tswitch(message->what)\n\t{\n\tdefault:\n\t\n\tbreak;\n\t}\n}";
SaveString << "\n\n//---------------------------------------------------------------";
SaveString << "\nvoid " << mviewview->mClassNameControl->Text() << "::Draw(BRect update)\n{";
SaveString << "\n\n}\n\n//---------------------------------------------------------------";
SaveString << "\nvoid " << mviewview->mClassNameControl->Text() << "::Pulse()\n{\n\n}\n\n";
fprintf(file, SaveString.String());
fclose(file);
//Make the view header file
tmp.SetTo(mselectview->mPathControl->Text());
tmp.Append("/");
tmp.Append(mviewview->mFileNameControl->Text());
tmp.Append(".h");
cout << tmp.String() << endl;
file = fopen(tmp.String(), "w");
//Add the content of that file
SaveString.SetTo("");
SaveString << "#ifndef _" << mviewview->mFileNameControl->Text() << "_h_\n";
SaveString << "#define _" << mviewview->mFileNameControl->Text() << "_h_\n";
SaveString << "\n//-----------------------  Local includes  ----------------------\n\n";
SaveString << "\n//----------------------- Global includes  ----------------------\n";
SaveString << "#include <AppKit.h>\n#include <SupportKit.h>\n#include <InterfaceKit.h>";
SaveString << "\n#include <iostream.h>\n#include <stdio.h>\n#include <stdlib.h>\n\n";
SaveString << "class " << mviewview->mClassNameControl->Text() << "\n\t\t: public BView";
SaveString << "\n{\npublic:\n\t\t\t\t\t\t" << mviewview->mClassNameControl->Text();
SaveString << "(BRect frame, const char *name, uint32 resizeMask, uint32 flags);";
SaveString << "\n\t\t\t\t\t\t~" << mviewview->mClassNameControl->Text() << "();";
SaveString << "\n\tvirtual void\t\tMessageReceived(BMessage *message);";
SaveString << "\n\tvoid\t\t\t\tDraw(BRect update);\n\tvoid\t\t\t\tPulse();";
SaveString << "\n\nprivate:\n\n\n};\n\n#endif\n\n";
fprintf(file, SaveString.String());
fclose(file);
}

//-----------------------------------------------------------------------
void mWindow::GenMake()
{
//Make the makefile
tmp.SetTo(mselectview->mPathControl->Text());
tmp.Append("/");
tmp.Append("makefile");
cout << tmp.String() << endl;
file = fopen(tmp.String(), "w");
//Add the content of that file
SaveString.SetTo("");
SaveString << "NAME= ../" << mselectview->mExecNameControl->Text();
SaveString << "\nTYPE= APP\nSRCS= " << mmainview->mFileNameControl->Text() << ".cpp";
	if (mselectview->mWindowCheckBox->Value() == true)
	{
	SaveString << " \\\n\t" << mwindowview->mFileNameControl->Text() << ".cpp";
	}
	if (mselectview->mViewCheckBox->Value() == true)
	{
	SaveString << " \\\n\t" << mviewview->mFileNameControl->Text() << ".cpp";
	}
SaveString << "\nRSRCS= \nLIBS= root \\\n\tbe \\\n\tstdc++.r4";
SaveString << "\nDEFINES= \nLIBPATHS= \n\nSYSTEM_INCLUDE_PATHS = \nLOCAL_INCLUDE_PATHS = \nDRIVER_PATH = ";
SaveString << "\n\nAPP_VERSION = \nDEBUGGER = \nLINKER_FLAGS = \nCOMPILER_FLAGS = \nSYMBOLS = \nWARNINGS = \n\n"; 
SaveString << "## include the makefile-engine\ninclude $(BUILDHOME)/etc/makefile-engine\n\n";
fprintf(file, SaveString.String());
fclose(file);

}



